#Set global error action
$ErrorActionPreference = 'Stop'

#Global Initialisation Variables
$WorkingDirectory = "$PSScriptRoot\working"
$ExecutionFile = (Join-Path $WorkingDirectory -ChildPath "localhost.mof")

#Clean current working directory
if(Test-Path($WorkingDirectory)){
    Remove-Item $WorkingDirectory -Recurse -Force
}
New-Item -Path $WorkingDirectory -ItemType Directory -Force

#Get All MOFS for this machine
$RoleMOFFiles = Get-ChildItem "$PSScriptRoot\DSC" -Recurse -Include "$env:COMPUTERNAME.mof"

#Print out the files that were found for this machine
Write-Output "Discovered:"
$RoleMOFFiles.FullName

foreach ($eachConfiguration in $RoleMOFFiles) {
    #Regenerate for execution
    Write-Output "Executing: $eachConfiguration"
    Copy-Item $eachConfiguration.FullName -Destination $ExecutionFile -Force -Verbose    
    Start-DscConfiguration -Path $WorkingDirectory -Wait -Verbose -Force -ComputerName 'localhost'
}
